package csir.helloworld.par;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.apache.log4j.Logger;
import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

/**
 * An ejb3 entity object that gets persisted
 * 
 * @author  <a href="mailto:louis.coetzee@csir.co.za">Louis Coetzee</a>
 */
@Entity
@Name("helloWorldEntity")
@Table(name="helloworld")
public class HelloWorldEntity implements Serializable {

	static final Logger logger = Logger.getLogger(HelloWorldEntity.class);

	private Integer version;
	private Integer id;

	
	/**
	 * Do the validation using the JSF validators 
	 */
	private String messageJSFValidation;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 9068648843995207571L;

	public HelloWorldEntity() {
		logger.info("Instantiated a HelloWorldEntity object");
	}
	@Id  @GeneratedValue(strategy=GenerationType.AUTO)
	@Column(name="hw_id",unique=true)
	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	
	@Version
	public Integer getVersion() {
		return version;
	}

	public void setVersion(Integer version) {
		this.version = version;
	}
	

	public String getMessageJSFValidation() {
		return messageJSFValidation;
	}
	public void setMessageJSFValidation(String messageJSFValidation) {
		this.messageJSFValidation = messageJSFValidation;
	}
}
