package csir.user.seam;

import org.jboss.security.*;

import java.io.*;

/**
 * @author lcoetzee
 *
 * Creates a SHA base64 encoded hash of password using login name as salt
 *
 */
import java.security.NoSuchAlgorithmException;

/**
 * Utitily class to encrypt a user password before persisting it to the database.
 * Uses SHA hash algorithm in conjunction with BASE64 hash encoding encoding.
 * 
 * See the file build/config/JAASExample-login-config.xml
 * 
 * @author <a href="mailto:louis.coetzee@csir.co.za">Louis Coetzee</a>
 *
 */
public class PWCrypt {
    /**
    *
    */
    public PWCrypt() {
    }

    private static String getStringFromKBD() {
        BufferedReader reader = new BufferedReader(new InputStreamReader(
                    System.in));

        try {
            return reader.readLine();
        } catch (Exception ex) {
            return "";
        }
    }

    public String genPW(String username, String password)
        throws NoSuchAlgorithmException {
        Util.init();

        return Util.createPasswordHash("SHA", Util.BASE64_ENCODING, "UTF-8",
            username, password);
    }

    public static void main(String[] args) {
        PWCrypt pw = new PWCrypt();
        System.out.println("Please provide user name");

        String userName = getStringFromKBD();

        System.out.println("Please provide password");

        String password = getStringFromKBD();

        try {
            System.out.println(pw.genPW(userName, password));
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
    }
}
